/*
 * Copyright (c) 2006 CTPP Dev Team
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 4. Neither the name of the CTPP Team nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *      Types.hpp
 *
 * $CTPP$
 */
#ifndef _TYPES_H__
#define _TYPES_H__ 1

#include <sys/types.h>

#ifdef linux

typedef __uint32_t  UINT_32;
typedef __int32_t   INT_32;
typedef __uint64_t  UINT_64;
typedef __int64_t   INT_64;
typedef double      W_FLOAT;

/* Character                 */
typedef char          CHAR_8;

/* Character                 */
typedef unsigned char UCHAR_8;

/* Constant character        */
typedef const char    CCHAR_8;

/* Address                   */
typedef CHAR_8 *      CHAR_P;

/* Address, pointer to const */
typedef CCHAR_8 *     CCHAR_P;

#endif

#ifdef __FreeBSD__
typedef uint32_t  UINT_32;
typedef int32_t    INT_32;
typedef uint64_t  UINT_64;
typedef int64_t    INT_64;
typedef double    W_FLOAT;

/* Character                 */
typedef char          CHAR_8;

/* Character                 */
typedef unsigned char UCHAR_8;

/* Constant character        */
typedef const char    CCHAR_8;

/* Address                   */
typedef caddr_t       CHAR_P;

/* Address, pointer to const */
typedef c_caddr_t     CCHAR_P;

#endif

#endif // _TYPES_H__
/* End. */
